Subject: Putting for discussion "__qdisc_run" bug - strange application-dependant error

From: Panadero Pizza <[email-masked]>
Date: Sat, 9 May 2009 19:55:04 +0000 (GMT)

Hello netdev group,

I would like to put for discussion, if a bug in the __qdsic_run function could explain the problem I have described in my post "Kernel networking problem (>=2.6.24.7)" two days ago.

"__qdisc_run" is the last common function in the kernel traces I receive for the kernels:

2.6.24.7
2.6.27.12

with a multi-threaded software, using fputc, putc, puts - calls, mixed with fflush()-calls on a remote file, opened on a cifs-handle. (Errors occur extremely seldom, although the software is running for hours - day after day)

I don't receive the error with other standard software (e.g. "dd"), writing to a file on the same cifs-handle/session and more interesting:
The error does not occur with the afore-mentioned multi-threaded program (or any other software), using a

2.6.16.62

kernel.

I have found that from 2.6.24.x on, the __qdisc_run function has been made preemptible and this feature has been enabled for the realization of the afore-said 2.6.24.7 and 2.6.27.12 kernels.

Though 2.6.16.62 solves my problem, I am offering participation in finding a solution for this (which should be fixed, if it is a kernel bug).

Best regards,
David